//
//  JOYTableViewController.m
//  My Focus
//
//  Created by 凡 刘 on 12-6-1.
//  Copyright (c) 2012年 北京帷幄昊合数字娱乐科技有限公司. All rights reserved.
//

#import "JOYTableViewController.h"
#import "JOYFocusUser.h"

@interface JOYTableViewController () {
@private
    NSMutableArray *_categoryList;
}

@end

@implementation JOYTableViewController

- (id)initWithStyle:(UITableViewStyle)style
{
    self = [super initWithStyle:style];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];

    // 设定pList文件路径
    NSString *dataPath = [[NSBundle mainBundle]pathForResource:@"FocusUsers.plist" ofType:nil];
    // 填充数组内容
    NSMutableArray *array = [NSMutableArray arrayWithContentsOfFile:dataPath];

    _categoryList = [[NSMutableArray alloc]init];
//    for (NSDictionary *item in array) {
//        NSMutableArray *userList = [[NSMutableArray alloc]init];
//        
//        // 针对每个分类项，创建一个用户数组
//        for (NSDictionary *users in item) {
//            JOYFocusUser *user = [[JOYFocusUser alloc]initWithItem:users];
//            [userList addObject:user];
//        }
//        
//        // 将用户数组项目添加到分类数组中
//        [_categoryList addObject:userList];
//    }
    for (NSMutableArray *item in array) {
        JOYCategory *category = [[JOYCategory alloc]initWithArray:item];
        [_categoryList addObject:category];
    }
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return [_categoryList count];
}

- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section {
//    // 获取指定区段的用户数组
//    NSMutableArray *userList = [_categoryList objectAtIndex:section];
//    // 获取数组中第一个用户记录
//    JOYFocusUser *user = [userList objectAtIndex:0];
//    // 返回该用户的分类名称
//    return user.categoryName;
    JOYCategory *category = [_categoryList objectAtIndex:section];
    return [category categoryName];
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
//    return [[_categoryList objectAtIndex:section]count];
    JOYCategory *category = [_categoryList objectAtIndex:section];
    return [category.userList count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"Cell";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    
    // Configure the cell...
    // 实例化单元格对象
    if (cell == nil) {
        cell = [[UITableViewCell alloc]initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier];
    }
    
//    NSMutableArray *array = [_categoryList objectAtIndex:[indexPath section]];
//    JOYFocusUser *user = [array objectAtIndex:[indexPath row]];
    JOYCategory *category = [_categoryList objectAtIndex:[indexPath section]];
    JOYFocusUser *user = [category.userList objectAtIndex:[indexPath row]];
    
    // 设置单元格文本
//    NSDictionary *item = [_userList objectAtIndex:indexPath.row];
    [cell.textLabel setText:[user userName]];
    // 设定字体
    [cell.textLabel setFont:[UIFont fontWithName:@"Helvetica" size:16.0f]];
    // 改变字体颜色
    [cell.textLabel setTextColor:[UIColor orangeColor]];
    // 调整文本居中对齐
    [cell.textLabel setTextAlignment:UITextAlignmentCenter];
    
    // 显示头像
    [cell.imageView setImage:[user image]];
    
    return cell;
}

/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/

/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
    }   
    else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
    }   
}
*/

/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath
{
}
*/

/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/

#pragma mark - Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Navigation logic may go here. Create and push another view controller.
    /*
     <#DetailViewController#> *detailViewController = [[<#DetailViewController#> alloc] initWithNibName:@"<#Nib name#>" bundle:nil];
     // ...
     // Pass the selected object to the new view controller.
     [self.navigationController pushViewController:detailViewController animated:YES];
     */
}

@end
